/**
 * C# Arrange of GNUGO 1.2
 * 
 * modified by Muzudho
 * last modified 2015-11-26
 *  
 * countlib.c
 * count.c    -> Util_CountLiberty.cs
 */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
using Grayscale.GPL.P___160_Collection_.L500_Collection;
using Grayscale.GPL.P___190_Board______.L063_Word;
using Grayscale.GPL.P___300_Taikyoku___.L500_Taikyoku;

namespace Grayscale.GPL.P340____Liberty____.L250_Liberty
{
    public abstract class Util_CountLiberty
    {
        /// <summary>
        /// Ղ̎w̌_ i,j ɂ΂N_ɁAȂĂ铯F̐΂̑o[eB𐔂܂B
        /// ċAIɌĂяo܂B
        /// Countlib֐ĂяoĂB
        /// 
        /// Gnugo1.2 ł́Acount֐łB
        /// </summary>
        /// <param name="libertyOfPiece">Gnugo1.2 ł́AO[oϐ lib łB</param>
        /// <param name="location">Gnugo1.2ł́Asԍ i = 0`18Aԍ j = 0`18B</param>
        /// <param name="color"> or </param>
        /// <param name="taikyoku"></param>
        private static void Count_Liberty_Recursive(
            ref int libertyOfPiece,
            GobanPoint location,
            StoneColor color,
            Taikyoku taikyoku
        )
        {
            //----------------------------------------
            // ̉
            //----------------------------------------
            // ΂̎SɂāA
            // ĂȂ󂫌_ł oeB[ PZ܂B
            // ĂȂāAw肵FiɓFj̐΂ł΁A̐΂瓯\bhċAĂяo܂B
            //

            // w肵ʒúAς݂Ƃă}[N܂B
            taikyoku.CountedBoard.Done_Current(location);

            // kׂ̐΂𒲂ׂ܂B
            if (!location.IsNorthEnd())//k[łȂ
            {
                if
                (
                    taikyoku.Goban.LookColor_NorthOf(location) == StoneColor.Empty
                    &&
                    taikyoku.CountedBoard.CanDo_North(location)
                )
                {
                    // kׂ󂢂Ă  ܂ĂȂȂA
                    // oeB[Pグ܂B͏dĐ܂B
                    ++libertyOfPiece;
                    taikyoku.CountedBoard.Done_North(location);
                }
                else if
                (
                    taikyoku.Goban.LookColor_NorthOf(location) == color
                    &&
                    taikyoku.CountedBoard.CanDo_North(location)
                )
                {
                    // kׂ wF̐΂uĂA܂ĂȂȂA
                    // ̐΂炳ɃJEg𑱂܂B
                    Util_CountLiberty.Count_Liberty_Recursive(ref libertyOfPiece, location.ToNorth(), color, taikyoku);
                }
                // w肵FłȂ΂uĂΉȂB
            }
            // ׂ𒲂ׂ܂B
            if (!location.IsSouthEnd(taikyoku.GobanBounds))//[łȂ
            {
                // A邾낤iOOj
                if
                (
                    taikyoku.Goban.LookColor_SouthOf(location) == StoneColor.Empty
                    &&
                    taikyoku.CountedBoard.CanDo_South(location)
                )
                {
                    ++libertyOfPiece;
                    taikyoku.CountedBoard.Done_South(location);
                }
                else if
                (
                    taikyoku.Goban.LookColor_SouthOf(location) == color
                    &&
                    taikyoku.CountedBoard.CanDo_South(location)
                )
                {
                    Util_CountLiberty.Count_Liberty_Recursive(ref libertyOfPiece, location.ToSouth(), color, taikyoku);
                }
            }
            // ׂ𒲂ׂ܂B
            if (!location.IsWestEnd())//[łȂ
            {
                if
                (
                    taikyoku.Goban.LookColor_WestOf(location) == StoneColor.Empty
                    &&
                    taikyoku.CountedBoard.CanDo_West(location)
                )
                {
                    ++libertyOfPiece;
                    taikyoku.CountedBoard.Done_West(location);
                }
                else if
                (
                    taikyoku.Goban.LookColor_WestOf(location) == color
                    &&
                    taikyoku.CountedBoard.CanDo_West(location)
                )
                {
                    Util_CountLiberty.Count_Liberty_Recursive(ref libertyOfPiece, location.ToWest(), color, taikyoku);
                }
            }
            // ׂ𒲂ׂ܂B
            if (!location.IsEastEnd(taikyoku.GobanBounds))//[łȂ
            {
                if
                (
                    (taikyoku.Goban.LookColor_EastOf(location) == StoneColor.Empty)
                    &&
                    taikyoku.CountedBoard.CanDo_East(location)
                )
                {
                    ++libertyOfPiece;
                    taikyoku.CountedBoard.Done_East(location);
                }
                else if
                (
                    taikyoku.Goban.LookColor_EastOf(location) == color
                    &&
                    taikyoku.CountedBoard.CanDo_East(location)
                )
                {
                    Util_CountLiberty.Count_Liberty_Recursive(ref libertyOfPiece, location.ToEast(), color, taikyoku);
                }
            }
        }


        /// <summary>
        /// Ղ̎w̌_ i,j ɂ΂N_ɁAȂĂ铯F̐΁icolor piecej̑o[eB𐔂܂B
        /// 
        /// Gnugo1.2 ł́Acountlib֐łB
        /// </summary>
        /// <param name="libertyOfPiece">Gnugo1.2 ł́AO[oϐ lib łB</param>
        /// <param name="startLocation_inPiece">Gnugo1.2ł́A sԍ m = 0`18Aԍ n = 0`18B</param>
        /// <param name="color"> or </param>
        public static void Count_LibertyOfPiece
        (
            out int libertyOfPiece,
            GobanPoint startLocation_inPiece,
            StoneColor color,
            Taikyoku taikyoku
        )
        {
            libertyOfPiece = 0;// Gnugo1.2 ł́Acountlib֐̌Ăяo O[oϐ lib = 0 Ă܂B


            // SẴs[X𐔂Ȃ悤ɁAZbg܂B
            taikyoku.CountedBoard.FillAll_WeCan(taikyoku.GobanBounds.BoardSize);

            // JgEs[X̃oeB[𐔂܂B
            Util_CountLiberty.Count_Liberty_Recursive(ref libertyOfPiece, startLocation_inPiece, color, taikyoku);
        }
    }
}