/**
 * C# Arrange of GNUGO 1.2
 * 
 * modified by Muzudho
 * last modified 2015-11-28
 *  
 * exambord.c -> new file.
 */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
using Grayscale.GPL.P___160_Collection_.L500_Collection;
using Grayscale.GPL.P___190_Board______.L063_Word;
using Grayscale.GPL.P___300_Taikyoku___.L500_Taikyoku;
using Grayscale.GPL.P160____Collection_.L500_Collection;
using Grayscale.GPL.P340____Liberty____.L500_LibertyAll;

namespace Grayscale.GPL.P350____RemoveStone.L500_RemoveStones
{
    /// <summary>
    /// ͂ꂽ΂AՏォ珜O܂BREɂȂȂǂAӂ܂B
    /// 
    /// Gnugo1.2 ł́Aexambord֐B
    /// </summary>
    public abstract class Util_RemoveStones_Surrounded
    {
        /// <summary>
        /// ͂ꂽ΂AՏォ珜O܂BREɂȂȂǂAӂ܂B
        /// 
        /// Gnugo1.2 ł́Aexambord֐B
        /// </summary>
        /// <param name="colorKo">ꂽ́A or </param>
        /// <param name="taikyoku"></param>
        public static void RemoveStones_Surrounded
        (
            StoneColor colorKo,
            Taikyoku taikyoku
        )
        {
            // Տ̑SẴ|CgɁA̐L܂B
            //
            // ̒n_AlłȂĂ΂̂܂ipieceĵƂA
            // ̃s[XŜł̃oeB[𐔂A|CĝPPɂ̐o܂B
            int[,] libertyOfPiece_eachPoint;           
            Util_CountLibertyAll.Count_LibertyOfPiece_EachPoint(out libertyOfPiece_eachPoint, colorKo, taikyoku);

            // ΂̈ʒu܂BiREŖ߂ȂĂ͂ȂȂ΂̈ʒuoẮj
            if (colorKo == taikyoku.MyColor)
            {
                taikyoku.MyKo.MoveToVanish();
            }
            else
            {
                taikyoku.YourKo.MoveToVanish();
            }


            // RE̓Ŏ΂̐B
            int countOfDelete = 0;

            // oeB[̂Ȃ΂͑SČԂ폜܂B
            // ܂lSĈ͂܂ꂽs[Xi΂̂܂jłB
            for (int i = 0; i < taikyoku.GobanBounds.BoardSize; i++)
            {
                for (int j = 0; j < taikyoku.GobanBounds.BoardSize; j++)
                {
                    GobanPoint location = new GobanPointImpl(i, j);

                    if
                    (
                        // 鑤̐΂łA
                        taikyoku.Goban.LookColor(location) == colorKo
                        &&
                        // s[X̃oeB[L^ĂȂȂ
                        libertyOfPiece_eachPoint[i,j] == 0
                    )
                    {
                        // ΂O܂B
                        taikyoku.Goban.Put(location, StoneColor.Empty);

                        // iŌɖ߂Ƃ̂Łj΂̈ʒuLAꂽ΂̐JEgAbv܂B
                        if (colorKo == taikyoku.MyColor)
                        {
                            // Rs[^[
                            taikyoku.MyKo.SetLocation(location);
                            ++taikyoku.Count_MyCaptured;
                        }
                        else
                        {
                            // lԑ
                            taikyoku.YourKo.SetLocation(location);
                            ++taikyoku.Count_YourCaptured;
                        }
                        ++countOfDelete;    // ̎wŎ̐H
                    }

                    // ΂QȏȂAREiKoj̉\ȂȂ܂B΂̈ʒűLZbg܂B
                    if (colorKo == taikyoku.MyColor && 1 < countOfDelete)
                    {
                        // Rs[^[΂̈ʒuiREɂȂ邩ȂjNA[B
                        taikyoku.MyKo.MoveToVanish();
                    }
                    else if (1 < countOfDelete) // TODO:  1 < countOfDelete ȂĂ̂H
                    {
                        // lԂ΂̈ʒuiREɂȂ邩ȂjNA[B
                        taikyoku.YourKo.MoveToVanish();   
                    }

                }//j
            }//i
        }

    }
}