/**
 * C# Arrange of GNUGO 1.2
 * 
 * modified by Muzudho
 * last modified 2015-11-28
 *  
 * findnext.c -> Util_SasiteNext.cs
 */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
using Grayscale.GPL.P___160_Collection_.L500_Collection;
using Grayscale.GPL.P___190_Board______.L063_Word;
using Grayscale.GPL.P___300_Taikyoku___.L500_Taikyoku;
using Grayscale.GPL.P160____Collection_.L500_Collection;
using Grayscale.GPL.P340____Liberty____.L250_Liberty;
using Grayscale.GPL.P403____CompThink__.L075_OwnEye;

namespace Grayscale.GPL.P403____CompThink__.L125_SasiteNext
{
    /// <summary>
    /// Rs[^[̎wT܂B
    /// 
    /// ċA܂BׁAׂƌčs܂B
    /// 
    /// findsavr Ŏg܂B
    /// </summary>
    public abstract class Util_SasiteNext
    {
        /// <summary>
        /// V]֐łB
        /// 
        /// Gnugo1.2 ł fval ֐B
        /// </summary>
        /// <param name="newLiberty"></param>
        /// <param name="iLiberty"></param>
        /// <returns></returns>
        private static int Evaluate
        (
            int newLiberty, // Gnugo1.2 ł newlib BVoeB[
            int iLiberty  // Gnugo1.2 ł minlib BoeB[̏Ȃ񂵂Ă郋[vJE^[B
        )
        {
            int result_score; // Gnugo1.2 ł val ϐB]l

            if (newLiberty <= iLiberty)
            {
                result_score = -1;   // ]l -1
            }
            else
            {
                int k = newLiberty - iLiberty;    // oeB[̍

                result_score = 40  // 40{ɁB
                        +
                        (k - 1) * 50    // oeB[̍̂悻 50{
                        /
                        (iLiberty * iLiberty * iLiberty)  // oeB[͂R̉l
                        ;
            }

            return result_score;
        }

        /// <summary>
        /// ʒum,n܂ރO[vAVw i,j T܂B
        ///
        /// Gnugo1.2 ł findnextmove ֐B
        /// </summary>
        /// <param name="out_location">̓   sAԍ</param>
        /// <param name="out_score">Gnugo1.2ł val ƂÕ|C^[ϐB̎w̕]l</param>
        /// <param name="curStone_location">JgEXg[ sԍ mAԍ n</param>
        /// <param name="iLiberty">JgEXg[̃oeB[BGnugo1.2 ł minlib ϐB</param>
        /// <param name="taikyoku"></param>
        /// <returns></returns>
        public static bool FindSasite
        (
            out GobanPoint out_location,
            out int out_score,
            GobanPoint curStone_location,
            int iLiberty,
            Taikyoku taikyoku
        )
        {
            GobanPoint tryLocation; // Gnugo1.2 ł ti,tj ƂϐB
            tryLocation = new GobanPointImpl(0, 0);// 2015-11-26 ǉ
            int tryScore = 0;    // Gnugo1.2 ł tval ϐB ׈ʒu̕]lB    // 2015-11-26 ǉ 0 ŏB
            bool found = false;

            out_location = new GobanPointImpl(-1,-1);
            out_score = -1;

            // Jgʒu}[N܂B
            taikyoku.MarkingBoard.Done_Current(curStone_location);

            //--------------------------------------------------------------------------
            // klCo[𒲂ׂ܂B
            if (!curStone_location.IsNorthEnd()) // k[łȂ΁B
            {
                if (taikyoku.Goban.LookColor_NorthOf(curStone_location) == StoneColor.Empty)
                {
                    // kׂ̈ʒui,jZbg
                    tryLocation.SetLocation(curStone_location.ToNorth());
            
                    // oeB[𐔂܂B
                    int libertyOfPiece; // Gnugo1.2 ł́AO[oϐ lib = 0 łB
                    Util_CountLiberty.Count_LibertyOfPiece(out libertyOfPiece, tryLocation, taikyoku.MyColor, taikyoku);
                    tryScore = Util_SasiteNext.Evaluate(libertyOfPiece, iLiberty);   // ]lvZ
            
                    found = true;
                }
                else if
                (
                    taikyoku.Goban.LookColor_NorthOf(curStone_location) == taikyoku.MyColor // kׂRs[^[̐΂ŁA
                    &&
                    taikyoku.MarkingBoard.CanDo_North(curStone_location) // kׂ̃}[LO 0 Ȃ
                )
                {
                    if (Util_SasiteNext.FindSasite(out tryLocation, out tryScore, curStone_location.ToNorth(), iLiberty, taikyoku))    // ċAIɌ
                    {
                        found = true;
                    }
                }
            }

            if (found)  // 1
            {
                found = false;
                if (out_score < tryScore && !Util_OwnEye.IsOwnEye(tryLocation, taikyoku))
                {
                    out_score = tryScore;    // ̕]lcĂH
                    out_location.SetLocation(tryLocation);// ̌_i,jcĂH
                }
            }

            //--------------------------------------------------------------------------
            // lCo[𒲂ׂ܂B
            if (!curStone_location.IsSouthEnd(taikyoku.GobanBounds))    // [łȂ΁B
            {
                if (taikyoku.Goban.LookColor_SouthOf(curStone_location) == StoneColor.Empty)
                {
                    // ׂ̈ʒui,jZbg
                    tryLocation.SetLocation(curStone_location.ToSouth());

                    int libertyOfPiece; // Gnugo1.2 ł́AO[oϐ lib = 0 łB
                    Util_CountLiberty.Count_LibertyOfPiece(out libertyOfPiece, tryLocation, taikyoku.MyColor, taikyoku);
                    tryScore = Util_SasiteNext.Evaluate(libertyOfPiece, iLiberty);
                    found = true;
                }
                else if
                (
                    taikyoku.Goban.LookColor_SouthOf(curStone_location) == taikyoku.MyColor
                    &&
                    taikyoku.MarkingBoard.CanDo_South(curStone_location) // 쑤
                )
                {
                    if (Util_SasiteNext.FindSasite(out tryLocation, out tryScore, curStone_location.ToSouth(), iLiberty, taikyoku))
                    {
                        found = true;
                    }
                }
            }

            if (found)  // 1
            {
                found = false;
                if (out_score < tryScore && !Util_OwnEye.IsOwnEye(tryLocation, taikyoku))
                {
                    out_score = tryScore;
                    out_location.SetLocation(tryLocation);
                }
            }

            //--------------------------------------------------------------------------
            // lCo[𒲂ׂ܂B
            if (!curStone_location.IsWestEnd()) // [łȂ΁B
            {
                if (taikyoku.Goban.LookColor_WestOf(curStone_location) == StoneColor.Empty)
                {
                    // ׂ̈ʒui,jZbg
                    tryLocation.SetLocation(curStone_location.ToWest());

                    int libertyOfPiece; // Gnugo1.2 ł́AO[oϐ lib = 0 łB
                    Util_CountLiberty.Count_LibertyOfPiece(out libertyOfPiece, tryLocation, taikyoku.MyColor, taikyoku);
                    tryScore = Util_SasiteNext.Evaluate(libertyOfPiece, iLiberty);
                    found = true;
                }
                else
                {
                    if (
                        taikyoku.Goban.LookColor_WestOf(curStone_location) == taikyoku.MyColor
                        &&
                        taikyoku.MarkingBoard.CanDo_West(curStone_location) // 
                        )
                    {
                        if (Util_SasiteNext.FindSasite(out tryLocation, out tryScore, curStone_location.ToWest(), iLiberty, taikyoku))
                        {
                            found = true;
                        }
                    }
                }
            }

            if (found)  // Ă 1
            {
                found = false;
                if (tryScore > out_score && !Util_OwnEye.IsOwnEye(tryLocation, taikyoku))
                {
                    out_score = tryScore;
                    out_location.SetLocation(tryLocation);
                }
            }

            //--------------------------------------------------------------------------
            // lCo[𒲂ׂ܂B
            if (!curStone_location.IsEastEnd(taikyoku.GobanBounds))    // [łȂ΁B
            {
                // p[m][n + 1] ׁ͓B
                if (taikyoku.Goban.LookColor_EastOf(curStone_location) == StoneColor.Empty)
                {
                    // ׂ̈ʒui,jZbg
                    tryLocation.SetLocation(curStone_location.ToEast());

                    int libertyOfPiece; // Gnugo1.2 ł́AO[oϐ lib = 0 łB
                    Util_CountLiberty.Count_LibertyOfPiece(out libertyOfPiece, tryLocation, taikyoku.MyColor, taikyoku);
                    tryScore = Util_SasiteNext.Evaluate(libertyOfPiece, iLiberty);
                    found = true;
                }
                else
                {
                    if
                    (
                        taikyoku.Goban.LookColor_EastOf(curStone_location) == taikyoku.MyColor
                        &&
                        taikyoku.MarkingBoard.CanDo_East(curStone_location) // 
                    )
                    {
                        if (Util_SasiteNext.FindSasite(out tryLocation, out tryScore, curStone_location.ToEast(), iLiberty, taikyoku))
                        {
                            found = true;
                        }
                    }
                }
            }

            if (found)  // Gnugo1.2ł́AĂ 1 łB
            {
                found = false;
                if (out_score < tryScore && !Util_OwnEye.IsOwnEye(tryLocation, taikyoku))
                {
                    out_score = tryScore;
                    out_location.SetLocation(tryLocation);
                }
            }

            //--------------------------------------------------------------------------
            if (0 < out_score)   // ̓B
            {
                return true;
            }
            else    // ͎̓sB
            {
                return false;
            }
        }
    }
}