/**
 * C# Arrange of GNUGO 1.2
 * 
 * modified by Muzudho
 * last modified 2015-11-28
 *  
 * matchpat.c -> Util_FindLocalZyoseki.cs
 */
/*
                 GNUGO - the game of Go (Wei-Chi)
                Version 1.2   last revised 10-31-95
           Copyright (C) Free Software Foundation, Inc.
                      written by Man L. Li
                      modified by Wayne Iba
        modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                    documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
using Grayscale.GPL.P___160_Collection_.L250_Rectangle;
using Grayscale.GPL.P___160_Collection_.L500_Collection;
using Grayscale.GPL.P___190_Board______.L063_Word;
using Grayscale.GPL.P___300_Taikyoku___.L500_Taikyoku;
using Grayscale.GPL.P___405_CompZyoseki.L125_LocalZyoseki;
using Grayscale.GPL.P160____Collection_.L500_Collection;
using Grayscale.GPL.P190____Board______.L500_Util;
using Grayscale.GPL.P340____Liberty____.L250_Liberty;
using Grayscale.GPL.P405____CompZyoseki.L125_LocalZyoseki;

namespace Grayscale.GPL.P405____CompZyoseki.L250_FindLocalZyoseki
{
    /// <summary>
    /// }b`p^[̓B
    /// 
    /// Gnugo1.2 ł matchpat֐B
    /// </summary>
    public abstract class Util_FindLocalZyoseki
    {
        /// <summary>
        /// ΒlB
        /// </summary>
        /// <param name="x"></param>
        /// <returns></returns>
        public static int Abs(int x)
        {
            return x < 0 ? -x : x;
        }

        /// <summary>
        /// ǂꂾĂ邩B
        /// 
        /// Gnugo1.2 ł line ֐B
        /// </summary>
        /// <param name="x"></param>
        /// <returns></returns>
        public static int DistanceFromCenter(int x, GobanRectangleA gobanBounds )
        {
            return Util_FindLocalZyoseki.Abs(x - gobanBounds.BoardCenter);
        }


        /// <summary>
        /// ]]ȂǁAՏς鑀̂߁itransfomationj̍s񂽂B[8][2][2]
        /// 
        /// 1A-1A0 Ȃ̂œ{B
        /// 
        /// s񎮂
        ///      
        ///  0 -1
        ///  1  0
        ///      
        /// ̂悤ȏ邪AvOł͌ɂBAAEAȄɕł̂ƂB
        /// 
        /// </summary>
        public static readonly int[,,] Trf =
        {
            // x         y     ͑
            // x,  y     x   y Α
            {{ 1,  0}, { 0,  1}},   // [0]͂ꂽWÂ܂܂łB  ilinear transfomation matrixj
            //      
            //  1  0
            //  0  1
            //      

            {{ 1,  0}, { 0, -1}},   // [1]㉺]                      iinvertj
            //      
            //  1  0
            //  0 -1
            //      

            {{ 0,  1}, {-1,  0}},   // [2]v90x]            irotate 90j
            //      
            //  0 -1
            //  1  0
            //      

            {{ 0, -1}, {-1,  0}},   // [3]v90x]ď㉺]  irotate 90 and invertj
            //      
            //  0 -1
            // -1  0
            //      

            {{-1,  0}, { 0,  1}},   // [4]E]                     iflip leftj
            //      
            // -1  0
            //  0  1
            //      

            {{-1,  0}, { 0, -1}},   // [5]E]ď㉺]            iflip left and invertj
            //      
            // -1  0
            //  0 -1
            //      

            {{ 0,  1}, { 1,  0}},   // [6]v90x]čE]  irotate 90 and flip leftj
            //      
            //  0  1
            //  1  0
            //      

            {{ 0, -1}, { 1,  0}}    // [7]v90x]čE]ď㉺]  irotate 90, flip left and invertj
            //                          i܂莞v90x]j
            //      
            //  0  1
            // -1  0
            //      
        };

        /// <summary>
        /// ՒΈȊÓAǒnIȒ΂ɂĂ͂܂邩ׁA΂Βuꏊ擾܂B
        /// </summary>
        /// <param name="out_location">̎ sAԍ</param>
        /// <param name="out_score">Gnugo1.2 ł val B]l</param>
        /// <param name="origin_location">Gnugo1.2 ł́A _   s mA n B</param>
        /// <param name="taikyoku"></param>
        /// <returns></returns>
        public static bool FindPattern
        (
            out GobanPoint out_location,
            out int out_score,
            GobanPoint origin_location,
            Taikyoku taikyoku
        )
        {
            GobanPoint tryLocation = new GobanPointImpl(0, 0); // Gnugo1.2 ł́Ati,tj ƂϐB// 2015-11-26 ǉ 0,0 ŏB

            out_location = new GobanPointImpl(-1,-1);
            out_score = -1;

            for (int ptnNo = 0; ptnNo < Util_LocalZyoseki.Patterns.Length; ptnNo++) // ꂼ̃p^[܂B
            {
                for (int ll = 0; ll < Util_LocalZyoseki.Patterns[ptnNo].LastTrfNo; ll++)/* try each orientation transformation */
                {
                    int k = 0;
                    bool isContinueLoop = true; // Gnugo1.2 ł contϐBcontinue̗H

                    //
                    // ɈvĂȂ̂Aӂ邢ƂĂ܂B
                    // ɈvĂ̂́Aǂǂ񎟂̃[vɐi݂܂B
                    //
                    while (
                        k != Util_LocalZyoseki.Patterns[ptnNo].Stones.Length
                        &&
                        isContinueLoop
                        )/* ̃|CgɈv */
                    {
                        //
                        // ό`itransformjāAՏ̍Wɕϊ܂B
                        //
                        int nx = 
                            origin_location.J
                            +
                            Util_FindLocalZyoseki.Trf[ll, 0, 0] * Util_LocalZyoseki.Patterns[ptnNo].Stones[k].P.X
                            +
                            Util_FindLocalZyoseki.Trf[ll, 0, 1] * Util_LocalZyoseki.Patterns[ptnNo].Stones[k].P.Y
                            ;

                        int my = 
                            origin_location.I
                            +
                            Util_FindLocalZyoseki.Trf[ll, 1, 0] * Util_LocalZyoseki.Patterns[ptnNo].Stones[k].P.X
                            +
                            Util_FindLocalZyoseki.Trf[ll, 1, 1] * Util_LocalZyoseki.Patterns[ptnNo].Stones[k].P.Y
                            ;

                        /* outside the board */
                        if (
                            !Util_AboutBoard.In_Board(my,taikyoku.GobanBounds)
                            ||
                            !Util_AboutBoard.In_Board(nx, taikyoku.GobanBounds)
                        )
                        {
                            isContinueLoop = false;
                            break;
                        }

                        GobanPoint mnLocation = new GobanPointImpl(my, nx);
                        switch (Util_LocalZyoseki.Patterns[ptnNo].Stones[k].Att)
                        {
                            case LocalZyoseki_StoneAttribute._0_Empty :
                                if (taikyoku.Goban.LookColor(mnLocation) == StoneColor.Empty)    /* open */
                                {
                                    break;
                                }
                                else
                                {
                                    isContinueLoop = false;
                                    break;
                                }
                            case LocalZyoseki_StoneAttribute._1_YourPiece:
                                if (taikyoku.Goban.LookColor(mnLocation) == taikyoku.YourColor)  /* your piece */
                                {
                                    break;
                                }
                                else
                                {
                                    isContinueLoop = false;
                                    break;
                                }
                            case LocalZyoseki_StoneAttribute._2_MyPiece:
                                if (taikyoku.Goban.LookColor(mnLocation) == taikyoku.MyColor)  /* my piece */
                                {
                                    break;
                                }
                                else
                                {
                                    isContinueLoop = false;
                                    break;
                                }
                            case LocalZyoseki_StoneAttribute._3_MyNextMove:
                                if (taikyoku.Goban.LookColor(mnLocation) == StoneColor.Empty)    /* open for new move */
                                {
                                    int libertyOfPiece; // Gnugo1.2 ł́AO[oϐ lib = 0 łB
                                    Util_CountLiberty.Count_LibertyOfPiece(out libertyOfPiece, mnLocation, taikyoku.MyColor, taikyoku);    /* check liberty */
                                    if (1 < libertyOfPiece)  /* move o.k. */
                                    {
                                        tryLocation.SetLocation(my,nx);
                                        break;
                                    }
                                    else
                                    {
                                        isContinueLoop = false;
                                        break;
                                    }
                                }
                                else
                                {
                                    isContinueLoop = false;
                                    break;
                                }
                            case LocalZyoseki_StoneAttribute._4_EmptyOnEdge:
                                if
                                (
                                    taikyoku.Goban.LookColor(mnLocation) == StoneColor.Empty  /* open on edge */
                                    &&
                                    (
                                        Util_AboutBoard.On_Edge(my, taikyoku.GobanBounds) || Util_AboutBoard.On_Edge(nx, taikyoku.GobanBounds)
                                    )
                                )
                                {
                                    break;
                                }
                                else
                                {
                                    isContinueLoop = false;
                                    break;
                                }
                            case LocalZyoseki_StoneAttribute._5_YourPieceOnEdge:
                                if
                                (
                                    taikyoku.Goban.LookColor(mnLocation) == taikyoku.YourColor  /* your piece on edge */
                                    &&
                                    (
                                        Util_AboutBoard.On_Edge(my, taikyoku.GobanBounds) || Util_AboutBoard.On_Edge(nx, taikyoku.GobanBounds)
                                    )
                                )
                                {
                                    break;
                                }
                                else
                                {
                                    isContinueLoop = false;
                                    break;
                                }
                            case LocalZyoseki_StoneAttribute._6_MyPieceOnEdge:
                                if
                                (
                                    taikyoku.Goban.LookColor(mnLocation) == taikyoku.MyColor  /* my piece on edge */
                                    &&
                                    (
                                        Util_AboutBoard.On_Edge(my, taikyoku.GobanBounds) || Util_AboutBoard.On_Edge(nx, taikyoku.GobanBounds)
                                    )
                                )
                                {
                                    break;
                                }
                                else
                                {
                                    isContinueLoop = false;
                                    break;
                                }
                        }
                        ++k;
                    }
            
                    if (isContinueLoop) // p^[ɈvĂ܂B
                    {
                        int tryScore = Util_LocalZyoseki.Patterns[ptnNo].Score; // Gnugo1.2 ł́Atval ϐB


                        if (
                            // p^[ԍ 8`13 ɂ́AVƃyieB[t܂B
                            8 <= ptnNo && ptnNo <= 13    /* patterns for expand region */
                           )
                        {
                            if (7 < Util_FindLocalZyoseki.DistanceFromCenter(tryLocation.I, taikyoku.GobanBounds))
                            {
                                // S 8ȏ㗣Ăi[ƁAׂ̗炢̈ʒujȂ΁AyieB[t܂B
                                tryScore--;
                            }
                            else if ((Util_FindLocalZyoseki.DistanceFromCenter(tryLocation.I, taikyoku.GobanBounds) == 6) || (Util_FindLocalZyoseki.DistanceFromCenter(tryLocation.I, taikyoku.GobanBounds) == 7))
                            {
                                // S 6`7 Ăʒui[3,4Ԗڂ炢jɂ́AV^܂B
                                tryScore++;
                            }

                            if (7 < Util_FindLocalZyoseki.DistanceFromCenter(tryLocation.J, taikyoku.GobanBounds))  /* penalty on line 1, 2 */
                            {
                                tryScore--;
                            }
                            else if ((Util_FindLocalZyoseki.DistanceFromCenter(tryLocation.J, taikyoku.GobanBounds) == 6) || (Util_FindLocalZyoseki.DistanceFromCenter(tryLocation.J, taikyoku.GobanBounds) == 7))
                            {
                                tryScore++;    /* reward on line 3, 4 */
                            }
                        }
                
                        if (tryScore > out_score)
                        {
                            out_score = tryScore;
                            out_location.SetLocation(tryLocation);
                        }
                    }
                }//for
            }

            if (0 < out_score)   // p^[Ƀ}b`܂B
            {
                return true;
            }
            else    // }b`Ɏs܂B
            {
                return false;
            }
        }
    }
}