/**
 * C# Arrange of GNUGO 1.2
 * 
 * modified by Muzudho
 * last modified 2015-11-28
 *  
 * findcolr.c -> Util_SeitiZi.cs
 */
/*
              GNUGO - the game of Go (Wei-Chi)
             Version 1.2   last revised 10-31-95
        Copyright (C) Free Software Foundation, Inc.
                   written by Man L. Li
                   modified by Wayne Iba
     modified by Frank Pursel <fpp%minor.UUCP@dragon.com>
                 documented by Bob Webber
*/
/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation - version 2.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License in file COPYING for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Please report any bug/fix, modification, suggestion to

           manli@cs.uh.edu
*/
using Grayscale.GPL.P___160_Collection_.L500_Collection;
using Grayscale.GPL.P___190_Board______.L063_Word;
using Grayscale.GPL.P___300_Taikyoku___.L500_Taikyoku;
using Grayscale.GPL.P160____Collection_.L500_Collection;

namespace Grayscale.GPL.P490____EndOfGame__.L250_SeitiZi
{
    /// <summary>
    /// n̒nB
    /// </summary>
    public abstract class Util_SeitiZi
    {

        /// <summary>
        /// nꂽnǂAmF܂B
        /// 
        /// ꏊPw肵A
        /// ̂S ΂ȂAF̐΂ō\ĂA
        /// ꏊ nĂ鎩̐wnƂĐB
        /// 
        /// Gnugo1.2 ł findcolr ֐B
        /// </summary>
        /// <param name="location">Gnugo1.2 ł́A sԍ i = 0`18Aԍ j = 0`18B</param>
        /// <param name="taikyoku"></param>
        /// <returns></returns>
        public static StoneColor Test_SeitiZi
        (
            GobanPoint location,
            Taikyoku taikyoku
        )
        {
            //----------------------------------------
            // ̐
            //----------------------------------------
            //
            // Տ̌_Pw肵܂B
            //
            // ɐ΂΁A̐FԂ܂B
            //
            // ΂Ȃ΁AS̒ōŏɓ˂΂̐F𒲂ׂ܂B
            // i܂ŁA̔Ԃ̓̂悤Ɂj
            //

            StoneColor result = StoneColor.Empty;     // F // 2015-11-26 ǉ EmptyŏB

            /// [0]kA[1]A[2]A[3]
            StoneColor[] color = new StoneColor[4];
                

            //
            // w肵Տ̈ʒuɐ΂΁A̐FԂ܂B
            //
            if (taikyoku.Goban.LookColor(location) != StoneColor.Empty)
            {
                return taikyoku.Goban.LookColor(location);
            }

            // klCo[A΂ɓ˂܂Œׂ܂B
            if (!location.IsNorthEnd())//k[łȂ
            {
                // w̍sԍ ` 0 ܂ŁB˂Ȃ k  k[ ܂ŁB
                int k = location.I; 
                do
                {
                    --k;
                }
                while (
                    taikyoku.Goban.LookColor(new GobanPointImpl(k, location.J)) == StoneColor.Empty
                    &&
                    0 < k
                );
                color[0] = taikyoku.Goban.LookColor(new GobanPointImpl(k, location.J));
            }
            else
            {
                // ہB
                color[0] = StoneColor.Empty;
            }

            // lCo[A΂ɓ˂܂Œׂ܂B
            if (!location.IsSouthEnd(taikyoku.GobanBounds))
            {
                // i18菬Aw̍sԍj` [ ܂ŁB
                int k = location.I;
                do
                {
                    ++k;
                }
                while
                (
                    taikyoku.Goban.LookColor(new GobanPointImpl(k, location.J)) == StoneColor.Empty
                    &&
                    k < taikyoku.GobanBounds.BoardEnd
                );
                color[1] = taikyoku.Goban.LookColor(new GobanPointImpl(k, location.J));
            }
            else
            {
                // ہB
                color[1] = StoneColor.Empty;
            }

            // lCo[A΂ɓ˂܂Œׂ܂B
            if (!location.IsWestEnd())
            {
                // i0傫Aw̗ԍj` 1 ܂ŁB
                int k = location.J;
                do
                {
                    --k;
                }
                while
                (
                    taikyoku.Goban.LookColor(new GobanPointImpl(location.I, k)) == StoneColor.Empty
                    &&
                    k > 0
                );
                color[2] = taikyoku.Goban.LookColor(new GobanPointImpl(location.I, k));
            }
            else
            {
                // ہB
                color[2] = StoneColor.Empty;
            }

            // lCo[A΂ɓ˂܂Œׂ܂B
            if (!location.IsEastEnd(taikyoku.GobanBounds))
            {
                // i18菬Aw̗ԍj` 17 ܂ŁB
                int k = location.J;
                do
                {
                    ++k;
                }
                while
                (
                    taikyoku.Goban.LookColor(new GobanPointImpl(location.I, k)) == StoneColor.Empty
                    &&
                    k < taikyoku.GobanBounds.BoardEnd
                );
                color[3] = taikyoku.Goban.LookColor(new GobanPointImpl(location.I, k));
            }
            else
            {
                // ہB
                color[3] = StoneColor.Empty;
            }

            // ŜAۂłȂ_̐FPm肽B
            for (int k=0;k<4;k++)
            {
                if (color[k] == StoneColor.Empty)
                {
                    continue;
                }
                else
                {
                    result = color[k];
                    break;
                }
            }

            // NX`FbN܂B
            //   킽G[ȂASĂ̎s[X͔ՂȂB
            // 킽͂C悤vC[ɑB
            for (int k=0;k<4;k++)
            {
                // Fݒ肳Ă̂ɁAԂʂ̐FĂG[łBłB
                if
                (
                    color[k] != StoneColor.Empty
                    &&
                    color[k] != result
                )
                {
                    return StoneColor.Empty;// 0;
                }
            }

            // A킽SẴ`FbNOK΁Aʂ|[g܂B
            return result;
        }
    }
}